using System;
using System.IO;
using System.Diagnostics;

namespace cmdftp
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			string tempFile = System.IO.Path.GetTempFileName();

			// wrong call -> show Help
			if(args.Length<5)
			{
				Console.WriteLine("CMDFTP usage");
				Console.WriteLine("Parameters:");
				Console.WriteLine("-h:[YOUR HOST]");
				Console.WriteLine("-u:[YOUR FTP USERNAME]");
				Console.WriteLine("-p:[YOUR FTO PASSWORD]");
				Console.WriteLine("-d:[SERVERDIRECTORY]");
				Console.WriteLine("-f:\"[FILE TO UPLOAD]\"");
				Console.WriteLine("");
				Console.WriteLine("Example: cmdftp.exe -h:ftp://test.com -u:user -p:root -d:/\"files/\" -f:\"C:/test.jpg\"");
				Console.WriteLine("");
				Console.WriteLine("... hit return to exit");
				Console.ReadLine();
				return;
			}
			else
			{
				string host     = "null";
				string username = "null";
				string password = "null";
				string filename = "null";
				string path     = "null";

				// parsing the intup
				foreach(string s in args)
				{
					if(s.IndexOf(":")!=-1)
					{
						string[]  split;
						split = s.Split(':');

						switch(split[0])
						{
							case "-h": host     = (split.Length>2)?split[1]+":"+split[2]:split[1]; break;
							case "-u": username = split[1];	break;
							case "-p": password = split[1]; break;
							case "-f": filename = (split.Length>2)?split[1]+":"+split[2]:split[1]; break;
							case "-d": path     = (split.Length>2)?split[1]+":"+split[2]:split[1]; break;
							default  : break;
						}
					}
				}

				// checking the parameters
				if(host.Equals("null") ||
					username.Equals("null") ||
					password.Equals("null") ||
					filename.Equals("null") ||
					path.Equals("null"))
				{
					//wrong parameters
					Console.WriteLine("Wrong parameter format");
				}
				else
				{
					// Writing the actual script
					try
					{
						Console.WriteLine("Writing script to {0}",tempFile);
						StreamWriter w = new StreamWriter(tempFile);
						w.WriteLine("OPEN");
						w.WriteLine("{0}",host);	
						w.WriteLine("{0}",username);
						w.WriteLine("{0}",password);
						w.WriteLine("CD {0}", path);
						w.WriteLine("PUT \"{0}\"",filename);
						w.WriteLine("BYE");
						w.Close();
					}
					catch(System.Exception e)
					{
						Console.WriteLine("Writing the tempfile failed");
						Console.WriteLine("{0}",e.Message);
						return;
					}

					// Starting FTP
					try
					{
						ProcessStartInfo p = new ProcessStartInfo();
						p.CreateNoWindow = false;
						p.FileName = "ftp.exe";
						p.Arguments ="-s:\""+tempFile+"\"";
						Process.Start(p);
					}
					catch(System.Exception e)
					{
						Console.WriteLine("Upload failed");
						Console.WriteLine("{0}",e.Message);
					}
				} 
			}

			Console.WriteLine("");
			Console.WriteLine("... please wait until the file has been uploaded,\n then hit return to delete the tempfile");
			Console.ReadLine();
			// Delete the Tempfile
			Console.WriteLine("Deleting the Tempfile");
			try
			{
				File.Delete(tempFile);
			}
			catch(System.Exception e)
			{
				Console.WriteLine("Deleting {0} failed",tempFile);
				Console.WriteLine("Please delete it by yourself - it contains username and password to your FTP-Server");
			}
			return;
		}
	}
}
